# ARTIK-SDK
   > This README explains how to use the node.js module for using the ARTIK SDK with JavaScript.

## Prerequisites

This package only works with node.js version 4.6.x or newer. It is tested on
4.x and 6.X LTS versions running on ARTIK boards (ARM 32 and 64 bit) only.

## Installation

The ARTIK SDK libraries must be installed prior to installing this node.js
module:

**Ubuntu:**
```bash
# apt install libartik-sdk
```

**Fedora:**
```bash
# dnf install libartik-sdk
```

Then install the node.js module:

```bash
# npm install artik-sdk
```

## API Documentation
### 1. Base
   * [Time API](/doc/TIME_README.md)

### 2. Bluetooth
   * [Bluetooth API](/doc/bluetooth/BLUETOOTH_README.md)
   * [Bluetooth Agent API](/doc/bluetooth/AGENT_README.md)
   * [Bluetooth AVRCP API](/doc/bluetooth/AVRCP_README.md)
   * [Bluetooth FTP API](/doc/bluetooth/FTP_README.md)
   * [Bluetooth GATT Client API](/doc/bluetooth/GATTCLIENT_README.md)
   * [Bluetooth GATT Server API](/doc/bluetooth/GATTSERVER_README.md)
   * [Bluetooth PAN API](/doc/bluetooth/PAN_README.md)
   * [Bluetooth SPP API](/doc/bluetooth/SPP_README.md)
   * [Bluetooth A2DP API](/doc/bluetooth/A2DP_README.md)

### 3. Connectivity
   * [ARTIK Cloud API](/doc/CLOUD_README.md)
   * [HTTP API](/doc/HTTP_README.md)
   * [Network API](/doc/NETWORK_README.md)
   * [Websocket API](/doc/WEBSOCKET_README.md)
   * [Security API](/doc/SECURITY_README.md)

### 4. Media
   * [Media API](/doc/MEDIA_README.md)

### 5. Sensors
   * [Sensors API](/doc/SENSOR_README.md)

### 6. Systemio
   * [ADC API](/doc/ADC_README.md)
   * [GPIO API](/doc/GPIO_README.md)
   * [I2C API](/doc/I2C_README.md)
   * [PWM API](/doc/PWM_README.md)
   * [Serial API](/doc/SERIAL_README.md)
   * [SPI API](/doc/SPI_README.md)

### 7. Wi-Fi
  * [Wi-Fi API](/doc/WIFI_README.md)

### 8. ZigBee
  * [ZigBee API](/doc/ZIGBEE_README.md)

### 9. LWM2M
  * [LWM2M API](/doc/LWM2M_README.md)

### 10. MQTT
  * [MQTT API](/doc/MQTT_README.md)

### 11. CoAP
  * [CoAP API](/doc/COAP_README.md)
